% an overcomplete 136 linear bases of dots, bars, and edges

% they are to be used for symbolic image representation

% the final goal is a representational theory of primal sketch 



ind = 0;     % indicator



scale = [0.5, 1, 1.5, 2, 2.5];    % scales

elong = [5, 3, 2];                % aspect ratios

rotate = [16, 12, 8];             % numbers of rotations 



for (i=1:5)           % a ridgelet system: the finer the scale,

   if (i<=2)          % the more enlongate the bases, and 

      m = 1;          % the more orentations 

   elseif (i<=4)

      m = 2;

   else 

      m = 3; 

   end

   R = rotate(m);

   for (j= 1:R)        % the orientations

      for (e=0:1)      % 0: odd and 1: even 

      ind = ind + 1; 

      if (e)

         [B.ker, C.ker] = doog(scale(i), (j-1)*180/R, elong(m)); 

      else

         [B.ker, C.ker] = doog1(scale(i), (j-1)*180/R, elong(m)); 

      end

      B.half = (size(B.ker, 1)-1)/2;  % half-size 

      B.sub = 1;                      % subsampling 

      F{ind} = B;                     % the base number ind 

      FS{ind} = B; 

      FS{ind}.ker = C.ker;            % the symbolic base 

      end

     end

  end

  

  gscale = [1, 2, 3, 4, 5, 6, 7, 8];   % dog base scales 

  for (i=1:8)

     ind = ind + 1; 

     [B.ker, C.ker] = dog(gscale(i));  

      B.half = (size(B.ker, 1)-1)/2;   % the half-size

      B.sub = 1;                       % subsampling

      F{ind} = B;                      % base number ind   

      FS{ind} = B;                     

      FS{ind}.ker = C.ker;             % symbolic base

  end

  

  C = corr(F);            % the correlation (inhibition) matrix 

  