function g = G(x, s)

% g = G(x, s)

% Gaussian density truncated to (-3, 3) with 0 ending 

% x: the difference from the mean

% s: the scale 



d = 3; p = .9974; 

x = x/s; 

if (abs(x)<d) 

   g = (exp(-x*x/2) - exp(-d*d/2))/sqrt(2*pi)/s; 

   g = g/(p-d*2/sqrt(2*pi)*exp(-d*d/2));    

else g = 0; 

end



   